(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define("Resource", [], factory);
	else if(typeof exports === 'object')
		exports["Resource"] = factory();
	else
		root["Resource"] = factory();
})(window, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "./src/index.ts");
/******/ })
/************************************************************************/
/******/ ({

/***/ "./src/index.ts":
/*!**********************!*\
  !*** ./src/index.ts ***!
  \**********************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var axios_1 = __webpack_require__(/*! axios */ "axios");
exports.defaultAxiosInstance = axios_1.default.create();
var Resource = /** @class */ (function () {
    /**
     * Constructor.
     * @param {string} endpoint
     */
    function Resource(endpoint) {
        var _this = this;
        this.endpoint = endpoint;
        /**
         * Instance values.
         */
        this.client = Resource.client;
        this.appendSlash = Resource.appendSlash;
        if (endpoint[0] === '/') {
            this.endpoint = endpoint.substr(1);
        }
        this.client.interceptors.request.use(function (config) {
            if (_this.appendSlash && !config.url.endsWith('/')) {
                config.url += '/';
            }
            return config;
        });
    }
    // per instance configuration methods
    /**
     * Override default client for this instance.
     *
     * @param {AxiosInstance} client
     * @returns {Resource}
     */
    Resource.prototype.withClient = function (client) {
        this.client = client;
        return this;
    };
    /**
     * Override default appendSlash for this instance.
     *
     * @param {boolean} appendSlash
     * @returns {Resource}
     */
    Resource.prototype.withAppendSlash = function (appendSlash) {
        this.appendSlash = appendSlash;
        return this;
    };
    // semantic helpers
    /**
     * Get a single object.
     * Makes HTTP GET request.
     *
     * @param {number} id
     * @param {AxiosRequestConfig} config
     * @returns {AxiosPromise<T>}
     */
    Resource.prototype.retrieve = function (id, config) {
        return this.get(this.url(id), config);
    };
    /**
     * Get an array of objects.
     * Makes HTTP GET request.
     *
     * @param {AxiosRequestConfig} config
     * @returns {AxiosPromise<T>}
     */
    Resource.prototype.list = function (config) {
        return this.get(this.url(), config);
    };
    /**
     * Create an object.
     * Makes HTTP POST request.
     *
     * @param {HttpParams} data
     * @param {AxiosRequestConfig} config
     * @returns {AxiosPromise<T>}
     */
    Resource.prototype.create = function (data, config) {
        return this.post(this.url(), data, config);
    };
    /**
     * Replace (update) an object.
     * Makes HTTP PUT request.
     *
     * @param {number} id
     * @param {HttpParams} data
     * @param {AxiosRequestConfig} config
     * @returns {AxiosPromise<T>}
     */
    Resource.prototype.update = function (id, data, config) {
        return this.put(this.url(id), data, config);
    };
    /**
     * Update an object.
     * Makes HTTP PATCH request.
     *
     * @param {number} id
     * @param {HttpParams} data
     * @param {AxiosRequestConfig} config
     * @returns {AxiosPromise<T>}
     */
    Resource.prototype.partialUpdate = function (id, data, config) {
        return this.patch(this.url(id), data, config);
    };
    /**
     * Delete an object.
     * Makes HTTP DELETE request.
     *
     * @param {number} id
     * @param {AxiosRequestConfig} config
     * @returns {AxiosPromise}
     */
    Resource.prototype.destroy = function (id, config) {
        return this.delete(this.url(id), config);
    };
    /**
     * Creates or replaces an object.
     * If id, then updates otherwise creates.
     * Makes HTTP POST | PUT request.
     *
     * @param {HttpParams} data
     * @param {number} id
     * @param {AxiosRequestConfig} config
     * @returns {AxiosPromise<T>}
     */
    Resource.prototype.createOrUpdate = function (data, id, config) {
        if (id) {
            return this.update(id, data, config);
        }
        return this.create(data, config);
    };
    /**
     * Creates or partially updates an object.
     * If id, then updates otherwise creates.
     * Makes HTTP POST | PATCH request.
     *
     * @param {HttpParams} data
     * @param {number} id
     * @param {AxiosRequestConfig} config
     * @returns {AxiosPromise<T>}
     */
    Resource.prototype.createOrPartialUpdate = function (data, id, config) {
        if (id) {
            return this.partialUpdate(id, data, config);
        }
        return this.create(data, config);
    };
    // generic methods here
    Resource.prototype.get = function (url, config) {
        return this.client.get(url, config);
    };
    Resource.prototype.post = function (url, data, config) {
        return this.client.post(url, data, config);
    };
    Resource.prototype.put = function (url, data, config) {
        return this.client.put(url, data, config);
    };
    Resource.prototype.patch = function (url, data, config) {
        return this.client.patch(url, data, config);
    };
    Resource.prototype.delete = function (url, config) {
        return this.client.delete(url, config);
    };
    /**
     * Build an URL from parts.
     * Pass an array of arguments to build a final URL.
     * Respects appendSlash option.
     *
     * Example (appendSlash = true):
     *    Resource.url('user', 'update', 100, 'force')
     *
     * Out: /api/user/update/100/force/
     *
     * @param {ValidURLParts} args
     * @returns {string}
     */
    Resource.prototype.url = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return [this.endpoint].concat(args).join('/');
    };
    /**
     * Axios instance.
     * @type {AxiosInstance}
     */
    Resource.client = exports.defaultAxiosInstance;
    /**
     * Autoappends slash to all URLs.
     * @type {boolean}
     */
    Resource.appendSlash = true;
    return Resource;
}());
exports.Resource = Resource;
exports.default = Resource;


/***/ }),

/***/ "axios":
/*!************************!*\
  !*** external "axios" ***!
  \************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("axios");

/***/ })

/******/ });
});
//# sourceMappingURL=index.js.map